Get an execution policy

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

GET https://api.ap1.datadoghq.com/api/v2/actions/execution-policies/{policy_id}https://api.ap2.datadoghq.com/api/v2/actions/execution-policies/{policy_id}https://api.datadoghq.eu/api/v2/actions/execution-policies/{policy_id}https://api.ddog-gov.com/api/v2/actions/execution-policies/{policy_id}https://api.us2.ddog-gov.com/api/v2/actions/execution-policies/{policy_id}https://api.uk1.datadoghq.com/api/v2/actions/execution-policies/{policy_id}https://api.datadoghq.com/api/v2/actions/execution-policies/{policy_id}https://api.us3.datadoghq.com/api/v2/actions/execution-policies/{policy_id}https://api.us5.datadoghq.com/api/v2/actions/execution-policies/{policy_id}

Overview

Retrieve an existing execution policy by ID. This endpoint requires the execution_groups_read permission.

Arguments

Path Parameters

Name

Type

Description

policy_id [required]

string

The ID of the execution policy.

Response

OK

Response object that includes a single execution policy.

Expand All

Field

Type

Description

data [required]

object

Object for a single execution policy.

attributes [required]

object

An execution policy.

action_pattern [required]

object

The set of actions this policy applies to.

action_fqns [required]

[string]

The fully qualified action names this policy matches. Use * to match all actions of the integration, or a fully qualified name prefixed with the integration's action namespace (for example com.datadoghq.script.* for the Script integration).

integration [required]

enum

The integration the action pattern applies to. Allowed enum values: INTEGRATION_KUBERNETES,INTEGRATION_SCRIPT,INTEGRATION_REMOTE_ACTION

created_at [required]

date-time

The date and time the execution policy was created.

created_by [required]

string

The ID of the user who created the execution policy.

effect [required]

enum

Whether the policy allows or denies matching actions. Allowed enum values: allow,deny

name [required]

string

The name of the execution policy.

scope

object

Restricts where the policy applies. At most one of kubernetes, scripts, or remote_action_rshell can be set. An empty object means the policy has no scope restriction.

kubernetes

object

Restricts the policy to specific Kubernetes namespaces.

rules [required]

[object]

The Kubernetes scope rules.

target_namespaces [required]

[string]

The Kubernetes namespaces this rule applies to.

remote_action_rshell

object

Restricts the policy to specific remote shell paths.

rules [required]

[object]

The remote shell scope rules.

access [required]

enum

The level of remote shell access granted for the target paths. Allowed enum values: read_only,read_write

target_paths [required]

[string]

The file system paths this rule applies to.

scripts

object

Restricts the policy to specific scripts.

rules [required]

[object]

The script scope rules.

target_script_names [required]

[string]

The script names this rule applies to.

targets [required]

[object]

The targets this policy applies to.

agent_tags [required]

[string]

The Agent tags identifying the target.

name

string

A human-readable name for the target.

updated_at [required]

date-time

The date and time the execution policy was last updated.

updated_by [required]

string

The ID of the user who last updated the execution policy.

version [required]

int32

The version of the execution policy. Incremented on every update.

id [required]

string

The ID of the execution policy.

type [required]

enum

The type of the resource. The value should always be execution_policy. Allowed enum values: execution_policy

default: execution_policy

{
  "data": {
    "attributes": {
      "action_pattern": {
        "action_fqns": [
          "com.datadoghq.script.*"
        ],
        "integration": "INTEGRATION_SCRIPT"
      },
      "created_at": "2026-01-15T10:00:00.000Z",
      "created_by": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
      "effect": "allow",
      "name": "Block prod restarts",
      "scope": {
        "kubernetes": {
          "rules": [
            {
              "target_namespaces": [
                "default"
              ]
            }
          ]
        },
        "remote_action_rshell": {
          "rules": [
            {
              "access": "read_only",
              "target_paths": [
                "/var/log"
              ]
            }
          ]
        },
        "scripts": {
          "rules": [
            {
              "target_script_names": [
                "restart_service.sh"
              ]
            }
          ]
        }
      },
      "targets": [
        {
          "agent_tags": [
            "env:prod"
          ],
          "name": "Production hosts"
        }
      ],
      "updated_at": "2026-01-15T10:00:00.000Z",
      "updated_by": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
      "version": 1
    },
    "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
    "type": "execution_policy"
  }
}

Forbidden

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Not Found

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                  # Path parameters
export policy_id="3fa85f64-5717-4562-b3fc-2c963f66afa6"
# Curl command
curl -X GET "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/actions/execution-policies/${policy_id}" \ -H "Accept: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}"
"""
Get an execution policy returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.execution_policy_api import ExecutionPolicyApi

# there is a valid "execution_policy" in the system
EXECUTION_POLICY_DATA_ID = environ["EXECUTION_POLICY_DATA_ID"]

configuration = Configuration()
configuration.unstable_operations["get_execution_policy"] = True
with ApiClient(configuration) as api_client:
    api_instance = ExecutionPolicyApi(api_client)
    response = api_instance.get_execution_policy(
        policy_id=EXECUTION_POLICY_DATA_ID,
    )

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
# Get an execution policy returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.get_execution_policy".to_sym] = true
end
api_instance = DatadogAPIClient::V2::ExecutionPolicyAPI.new

# there is a valid "execution_policy" in the system
EXECUTION_POLICY_DATA_ID = ENV["EXECUTION_POLICY_DATA_ID"]
p api_instance.get_execution_policy(EXECUTION_POLICY_DATA_ID)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
// Get an execution policy returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "execution_policy" in the system
	ExecutionPolicyDataID := os.Getenv("EXECUTION_POLICY_DATA_ID")

	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.GetExecutionPolicy", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewExecutionPolicyApi(apiClient)
	resp, r, err := api.GetExecutionPolicy(ctx, ExecutionPolicyDataID)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ExecutionPolicyApi.GetExecutionPolicy`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ExecutionPolicyApi.GetExecutionPolicy`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
// Get an execution policy returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ExecutionPolicyApi;
import com.datadog.api.client.v2.model.ExecutionPolicyResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.getExecutionPolicy", true);
    ExecutionPolicyApi apiInstance = new ExecutionPolicyApi(defaultClient);

    // there is a valid "execution_policy" in the system
    String EXECUTION_POLICY_DATA_ID = System.getenv("EXECUTION_POLICY_DATA_ID");

    try {
      ExecutionPolicyResponse result = apiInstance.getExecutionPolicy(EXECUTION_POLICY_DATA_ID);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ExecutionPolicyApi#getExecutionPolicy");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
// Get an execution policy returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_execution_policy::ExecutionPolicyAPI;

#[tokio::main]
async fn main() {
    // there is a valid "execution_policy" in the system
    let execution_policy_data_id = std::env::var("EXECUTION_POLICY_DATA_ID").unwrap();
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.GetExecutionPolicy", true);
    let api = ExecutionPolicyAPI::with_config(configuration);
    let resp = api
        .get_execution_policy(execution_policy_data_id.clone())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * Get an execution policy returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.getExecutionPolicy"] = true;
const apiInstance = new v2.ExecutionPolicyApi(configuration);

// there is a valid "execution_policy" in the system
const EXECUTION_POLICY_DATA_ID = process.env.EXECUTION_POLICY_DATA_ID as string;

const params: v2.ExecutionPolicyApiGetExecutionPolicyRequest = {
  policyId: EXECUTION_POLICY_DATA_ID,
};

apiInstance
  .getExecutionPolicy(params)
  .then((data: v2.ExecutionPolicyResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"